#include <Boards.h>
#include <Firmata.h> 

int mat_aux [10][3]; // crear matriz para pasar datos a luces
int mat [10][3];

int largo = 10;

int color = 3; // color rgb
int cantidad_esperada = 20; // num pixels

int encabezado = 255;
int cierre = 254;

int indice = 0;  // variables para indicar que es cada dato que llega
int indice_x = 0;
int indice_color = 0;
int pin_led = 13; // led indicador de que se estan recibiendo datos
boolean estado_pin = false;


//sensor color 
#include <Adafruit_NeoPixel.h>  
#ifdef __AVR__  
#include <avr/power.h>  
#endif  
   
 // Which pin on the Arduino is connected to the NeoPixels?  
#define PINsensor      7  
   
 // How many NeoPixels are attached to the Arduino?  
#define NUMPIXELS   10 
//sensor color 


///control luces

#include <Adafruit_NeoPixel.h> // libreria pixel led
#ifdef __AVR__
#include <avr/power.h>
#endif

#define PIN 6 // pin donde conecto luces
Adafruit_NeoPixel strip = Adafruit_NeoPixel(10, PIN, NEO_GRB + NEO_KHZ800); // cant pixels

//sensor color 
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PINsensor, NEO_GRB + NEO_KHZ800);  

volatile int state = LOW;
   
int delayval = 333; // delay  
 
#define S0 1
#define S1 2
#define S2 3
#define S3 4
#define sensorOut 5
 
int frequency = 0;
int Red, Green, Blue;
//sensor color 


void setup() {
  Serial.begin(115200); // seteo velocidad a la misma que manda processing
   delay(1000);
  pinMode(pin_led, OUTPUT); 


  strip.begin(); // inicio strip
  strip.show(); // Inicio pixels en off

//sensor color
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);
 
  // Setting frequency-scaling to 20%
  digitalWrite(S0,HIGH);
  digitalWrite(S1,LOW);
 
  Serial.begin(115200);
  pixels.begin(); // This initializes the NeoPixel library. 
//sensor color



}

void loop() {

  while (Serial.available () > 0) {

    int inByte = Serial.read();
    if (inByte == encabezado) {
          indice=0;
      
        } //leo datos y los meto en una variable
    switch (indice) {
      case 0://indice == 0 miro que el byte sea = al encabezado
        if (inByte == encabezado) {
          indice++;
          indice_x = 0;
          indice_color = 0;
          
        }
        break;
      
      case 1://indice == 1 cantidad de mensajes
        mat_aux[indice_x][indice_color] = inByte;
        indice_color++;
        if (indice_color >= 3) {
          indice_color = 0;
          indice_x++;
          if (indice_x >= largo) {
            indice_x = 0;
            indice++;
              break;
            }
          }
      


        break;

      case 2://indice == 2 miro que el byte sea el final del mensaje

        if (inByte == cierre) {

          copio_vector(); // ejecuto funcion
        }
        indice = 0;//espero un nuevo mensaje
        break;
    }
   }


//sensor color
// Setting red filtered photodiodes to be read
  digitalWrite(S2,LOW);
  digitalWrite(S3,LOW);
  // Reading the output frequency
  frequency = pulseIn(sensorOut, LOW);
  //Remaping the value of the frequency to the RGB Model of 0 to 255
  frequency = map(frequency, 25,72,255,0);
  if (frequency < 0) {
    frequency = 0;
  }
  if (frequency > 255) {
    frequency = 255;
  }
  Red= frequency;
  // Printing the value on the serial monitor
  Serial.print("R= ");//printing name
  Serial.print(frequency);//printing RED color frequency
  Serial.print("  ");
  delay(100);
 
  // Setting Green filtered photodiodes to be read
  digitalWrite(S2,HIGH);
  digitalWrite(S3,HIGH);
  // Reading the output frequency
  frequency = pulseIn(sensorOut, LOW);
  //Remaping the value of the frequency to the RGB Model of 0 to 255
  frequency = map(frequency, 30,90,255,0);
  if (frequency < 0) {
    frequency = 0;
  }
  if (frequency > 255) {
    frequency = 255;
  }
  Green = frequency;
  // Printing the value on the serial monitor
  Serial.print("G= ");//printing name
  Serial.print(frequency);//printing RED color frequency
  Serial.print("  ");
  delay(100);
 
  // Setting Blue filtered photodiodes to be read
  digitalWrite(S2,LOW);
  digitalWrite(S3,HIGH);
  // Reading the output frequency
  frequency = pulseIn(sensorOut, LOW);
  //Remaping the value of the frequency to the RGB Model of 0 to 255
  frequency = map(frequency, 25,70,255,0);
  if (frequency < 0) {
    
    frequency = 0;
  }
  if (frequency > 255) {
    frequency = 255;
  }
  Blue = frequency;
  // Printing the value on the serial monitor
  Serial.print("B= ");//printing name
  Serial.print(frequency);//printing RED color frequency
  Serial.println("  ");
  pixels.setPixelColor(0, pixels.Color(Red,Green,Blue)); // Moderately bright green color.

//nuevo
  pixels.setPixelColor(1, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(2, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(3, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(4, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(5, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(6, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(7, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(8, pixels.Color(Red,Green,Blue));
  pixels.setPixelColor(9, pixels.Color(Red,Green,Blue));
 
//nuevo
 
  pixels.setBrightness(64);  
  pixels.show(); // This sends the updated pixel color to the hardware.
  delay(100);
//sensor color




}

void copio_vector() {

  for (int i = 0; i < largo; i++) {
      for (int c = 0; c < 3; c++) {
        mat[i][c] = mat_aux[i][c]; //
      }
  }

  for (int i = 0; i < largo ; i++) {
   
    
      strip.setPixelColor(i, strip.Color( mat_aux[i][0],  mat_aux[i][1],  mat_aux[i][2]));
   //strip.setPixelColor(num pixel), strip.Color( red,  green, blue));
    
    
  }


  strip.show();


  digitalWrite(pin_led, HIGH);
  delay(2);
  digitalWrite(pin_led, LOW);//muestro que estoy recibiendo datos
  

}
